// game_menu.cpp

#include "game.h"

gameMenu_t::gameMenu_t()
{
	bloodDrips *blankDrip = new bloodDrips;

	currentMenu = BLOODMENU_OFF;
	for(int i = 0; i < 7; i++)
	{
		menuDrips.push_back(blankDrip);
	}
	tmpNum = 0;
	handleEscape = false;
}

/*
=======================================
void gameMenu_t::SetMenu(int menuID)
=======================================
*/

void gameMenu_t::SetMenu(int menuID)
{
	// Menu can only be switched off in game
/*
	if(thisGame->g_PlayerInGame() != true && MenuActive)
	{
		currentMenu = BLOODMENU_OFF;
		return;
	}
*/
	if(menuID == BLOODMENU_ESC)
	{
		handleEscape = true;
		//menuID = BLOODMENU_MAIN;
		if(currentMenu > 0)
			return;
	}
	//if(currentMenu > 0)
	//	lastMenu     = currentMenu;

	currentMenu  = menuID;
	FlushMenu();
	slot = 0;
	build_func->nextpage();
}

/*
==================================
void gameMenu_t::FlushMenu(void)
==================================
*/

void gameMenu_t::FlushMenu(void)
{
	currentMenuItems.clear();
	thisMenuFunc.clear();

	if(currentMenuItems.empty() == false)
		printf("WARNING: Unable to clear menu buffer\n");
}

/*
=======================================================
void gameMenu_t::AddItemToMenu(menuItems_t *thisItem)
=======================================================
*/

void gameMenu_t::AddItemToMenu(menuItems_t *thisItem)
{
	currentMenuItems.push_back(thisItem);
}

/*
======================================
void gameMenu_t::DrawThisMenu(void)
======================================
*/

void gameMenu_t::ThisMenuMain(void)
{
	if(build_func->build_KeyDown(sc_DownArrow))
	{
		slot++;
		if(slot > currentMenuItems.size()-1)
			slot = 0;
	}
	if(build_func->build_KeyDown(sc_UpArrow))
	{
		slot--;
		if(slot < 0)
			slot = currentMenuItems.size()-1;
	}

	for(int i = 0; i < currentMenuItems.size(); i+=1)
	{
		if(slot == i)
			guimanager->DrawTextLight((char *)currentMenuItems.at(i)->name.c_str(),fontNum,currentMenuItems.at(i)->x,currentMenuItems.at(i)->y);
		else
			guimanager->DrawText((char *)currentMenuItems.at(i)->name.c_str(),fontNum, currentMenuItems.at(i)->x,currentMenuItems.at(i)->y);
	//	printf("%s\n",(char *)currentMenuItems.at(i)->name.c_str());
	}
}

/*
===================================
void gameMenu_t::menu_quit(void)
===================================
*/

void gameMenu_t::menu_quit(void)
{
	thisGame->exit_game = true;
}

/*
=======================================
void gameMenu_t::menu_diffculty(void)
=======================================
*/

void gameMenu_t::menu_diffculty(void)
{
	menuItems_t *diff1	   = CreateBloodMenu("Still Kicking",NULL,93,50);
	menuItems_t *diff2	   = CreateBloodMenu("Pink on the Inside",NULL,73,70);
	menuItems_t *diff3	   = CreateBloodMenu("Lightly Brioled",NULL,73,90);
	menuItems_t *diff4	   = CreateBloodMenu("Well done",NULL,110,110);
	menuItems_t *diff5	   = CreateBloodMenu("Extra Crispy",NULL,103,130);

	fontNum = 4257;

	build_func->rotatesprite(148<<16,20<<16,65536L,0,2038,4,0,10,0,0,800-1,600-1);
	guimanager->DrawTextNoFlash("DIFFCULTY",113,20);

	lastMenu = BLOODMENU_EPISODE;
	
	AddItemToMenu(diff1);
	AddItemToMenu(diff2);
	AddItemToMenu(diff3);
	AddItemToMenu(diff4);
	AddItemToMenu(diff5);
}

/*
======================================
void gameMenu_t::menu_saveGame(void)
======================================
*/

void gameMenu_t::menu_saveGame(void)
{
	FILE        *thisSave[8];
	menuItems_t *saveSlots[8];
	char        *tempBuf = new char[20];
	char		savName[20];

	for(int i = 0; i < 8; i++)
	{
		sprintf(tempBuf,"blood00%d.sav",i);
		thisSave[i]   = fopen(tempBuf,"rb");

		if(thisSave[i] == NULL)
		{
			sprintf(savName,"<save game>");
		}
		else
		{
			
		}

		saveSlots[i]  = CreateBloodMenu(savName,NULL,160,50 + (i * 10));
	}

	fontNum = 4161;

	build_func->rotatesprite(148<<16,20<<16,65536L,0,2038,4,0,10,0,0,800-1,600-1);
	guimanager->DrawTextNoFlash("SAVE GAME",116,20);

	lastMenu = BLOODMENU_MAIN;

	if(build_func->build_KeyDown(sc_Enter))
	{
		saveGame_t *thisSaveGame;

		sprintf(tempBuf,"blood00%d.sav",slot);
		thisSave[slot]   = fopen(tempBuf,"wb");
		sprintf(tempBuf,"Level %s Time %d:%d",thisGame->thisBoard,1,1);

		if(thisSave[slot] == NULL)
		{
			printf("WARNING: Failed to open save game for writing %s\n",tempBuf);
			return;
		}

		thisSaveGame = new saveGame_t(tempBuf,10,100,1,0);

		fseek(thisSave[slot],0,SEEK_SET);
		fwrite(thisSaveGame,sizeof(saveGame_t),1,thisSave[slot]);
        fclose(thisSave[slot]);
		
	}

	for(int i = 0; i < 8; i++)
	{
		AddItemToMenu(saveSlots[i]);
		if(thisSave[slot] != NULL)
			fclose(thisSave[slot]);
	}
}

/*
====================================
void gameMenu_t::menu_episode(void)
====================================
*/

void gameMenu_t::menu_episode(void)
{
	menuItems_t *episode1	   = CreateBloodMenu("The way of all flesh",NULL,60,50);
	menuItems_t *episode2	   = CreateBloodMenu("Even death may die",NULL,70,70);
	menuItems_t *episode3	   = CreateBloodMenu("Farewell to arms",NULL,82,90);
	menuItems_t *episode4	   = CreateBloodMenu("Dead Reckoning",NULL,89,110);
	menuItems_t *episode5	   = CreateBloodMenu("Post Mortem",NULL,98,130);

	build_func->rotatesprite(148<<16,20<<16,65536L,0,2038,4,0,10,0,0,800-1,600-1);
	guimanager->DrawTextNoFlash("EPISODE",126,20);

	if(build_func->build_KeyDown(sc_Enter))
	{
		this->pEpisode = slot;
		SetMenu(BLOODMENU_DIFFUC);
		return;
	}

	fontNum = 4257;

	lastMenu = BLOODMENU_MAIN;

	AddItemToMenu(episode1);
	AddItemToMenu(episode2);
	AddItemToMenu(episode3);
	AddItemToMenu(episode4);
	AddItemToMenu(episode5);
}

/*
=================================
void gameMenu_t::menu_main(void)
=================================
*/

void gameMenu_t::menu_main(void)
{
	menuItems_t *newGame         = CreateBloodMenu("NEW GAME",NULL,115,50);
	menuItems_t *multiplayer     = CreateBloodMenu("MULTIPLAYER",NULL,100,70);
	menuItems_t *options         = CreateBloodMenu("OPTIONS",NULL,120,90);
	menuItems_t *loadgame        = CreateBloodMenu("LOAD GAME",NULL,110,110);
	menuItems_t *savegame        = CreateBloodMenu("SAVE GAME",NULL,110,130);
	menuItems_t *help            = CreateBloodMenu("HELP",NULL,132,130);
	menuItems_t *credits         = CreateBloodMenu("CREDITS",NULL,120,150);
	menuItems_t *quit            = CreateBloodMenu("QUIT",NULL,132,170);

	build_func->rotatesprite(148<<16,20<<16,65536L,0,2038,4,0,10,0,0,800-1,600-1);
	guimanager->DrawTextNoFlash("BLOOD",130,20);
	
	fontNum = 4257;

	if(build_func->build_KeyDown(sc_Enter))
	{
		if(slot == 0)
			SetMenu(BLOODMENU_EPISODE);
		//if(slot == 4 && thisGame->g_PlayerInGame() == true)
		//	SetMenu(BLOODMENU_SAVEG);
		if(slot == 6)
			menu_quit();

		return;
	}

	//if(currentMenuItems.size() > 0)
	//	return;

	AddItemToMenu(newGame);
	AddItemToMenu(multiplayer);
	AddItemToMenu(options);
	AddItemToMenu(loadgame);
	if(thisGame->g_PlayerInGame() == false)
		AddItemToMenu(help);
	else
		AddItemToMenu(savegame);
	AddItemToMenu(credits);
	AddItemToMenu(quit);
}


/*
======================================
void gameMenu_t::DrawBloodDrips(void)
======================================
*/

void gameMenu_t::DrawBloodDrips(void)
{
	int bloodState = ((6+(build_func->ftotalclock()>>3))%7);
	int bloodTile = MENUBLOOD+6-bloodState;
#if 0
	// Reset the drips on change frame

	switch(bloodState)
	{
		case 6:
			menuDrips.at(6)->x = 20;
			menuDrips.at(6)->y = 0;
		break;
		case 5:
			menuDrips.at(5)->x = 50;
			menuDrips.at(5)->y = 0;
		break;
		case 4:
			menuDrips.at(4)->x = 240;
			menuDrips.at(4)->y = 0;
		break;
		case 3:
			menuDrips.at(3)->x = 300;
			menuDrips.at(3)->y = 0;
		break;
		case 2:
			menuDrips.at(2)->x = 170;
			menuDrips.at(2)->y = 0;
		break;
		case 1:
			menuDrips.at(1)->x = 130;
			menuDrips.at(1)->y = 0;
		break;
		case 0:
			menuDrips.at(0)->x = 200;
			menuDrips.at(0)->y = 0;
		break;
	}

	//for(int i = 0; i < 7; i++)
	//{
		// Draw the blood drips
		menuDrips.at(tmpNum)->y+=30;
		//printf("Creating drops at %d: %d %d\n",tmpNum,menuDrips.at(tmpNum)->x,menuDrips.at(tmpNum)->y);
		build_func->rotatesprite(menuDrips.at(tmpNum)->x<<16,menuDrips.at(tmpNum)->y<<16,65536L,0,2028,16,0,10,0,0,800-1,600-1);
	//}
	tmpNum++;
	if(tmpNum > 6)
		tmpNum = 0;
#endif
	build_func->rotatesprite(160<<16,5<<16,65536L,0,bloodTile,4,0,10,0,0,800-1,600-1);
	//build_func->Set_Brightness(30);
	//build_func->nextpage();
}

/*
======================================
boolean gameMenu_t::MenuActive(void)
======================================
*/

boolean gameMenu_t::MenuActive(void)
{
	if(currentMenu == BLOODMENU_OFF)
		return true;
	else
		return false;
}

/*
================================
void gameMenu_t::DrawMenu(void)
================================
*/
void gameMenu_t::DrawMenu(void)
{
	if(currentMenu == BLOODMENU_OFF) // No menu to display.
		return;
	
	if(thisGame->g_PlayerInGame() == false) // don't force the background in game
		guimanager->DrawTile(MENUBK,0,0,320,200);

	if(handleEscape)
	{
		if(currentMenu != BLOODMENU_MAIN)
		{
			if(currentMenu != BLOODMENU_ESC)
				SetMenu(this->lastMenu);
			else
				SetMenu(BLOODMENU_MAIN);
		}
		else
		{
			if(thisGame->g_PlayerInGame() == true)
			{
				SetMenu(BLOODMENU_OFF);
				thisGame->ReRunAI();
			}
		}
		handleEscape = false;
	}

	if(currentMenu == BLOODMENU_MAIN)
	{
		menu_main();
	}
	else if(currentMenu == BLOODMENU_EPISODE)
	{
		menu_episode();
	}
	else if(currentMenu == BLOODMENU_DIFFUC)
	{
		menu_diffculty();
	}
	else if(currentMenu == BLOODMENU_SAVEG)
	{
		menu_saveGame();
	}


	ThisMenuMain();
	DrawBloodDrips();
	FlushMenu();
	//DrawIcon();
}