//-------------------------------------------------------------------------
/*
Copyright (C) 2005 - Justin Marshall

This file is part of the blood reconstruction project.

WinBlood is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

PORTIONS OF CODE FROM DUKE NUKEM 3D SOURCE CODE
*/
//-------------------------------------------------------------------------
// packets.h

#pragma pack(1)

//
// packet_login
// client sends when it first connects
//

struct packet_login
{
	byte  packetID;       // 0xA1
	char playername[40];  // players name
	char password[10];    // players password

	packet_login::packet_login()
	{
		packetID = 0xA1;
	}
};

//
// packet_worldchange
// Sent everytime the world changes or when player first enters server
//

struct packet_worldchange
{
	byte  packetID;		  // 0xA2
	char  boardname[20];  // name of the current board
	char  motd[100];      // message of the day for server
	int   gametype;       // 0=deathmatch, 1=coop, 2=capture the flag
	int   playerid;       // your unique player ID
	int   numents;        // number of entities to request server for
	int   numplayers;     // number of current players
	int   scores[8];      // deathmatch scores for all nonactive/active players
	packet_worldchange::packet_worldchange()
	{
		packetID = 0xA2;
	}
};

//
// packet_clientinworld
// Sent when client has finished loading
//


struct packet_clientinworld
{
	byte packetID;		  // 0xA3
	packet_clientinworld::packet_clientinworld()
	{
		packetID = 0xA3;
	}
};